#include <gccore.h>
#include <ogcsys.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <fat.h>
#include <sys/dir.h>

#include "gb.h"
#include "sound.h"
#include "filer.h"
#include "screen.h"
#include "menu.h"

static inline unsigned long long mftb(void)
{
	register u32 tbu, tbl, tmp;

	asm volatile(
		"0:\n\t"
		"mftbu %0\n\t"
		"mftb %1\n\t"
		"mftbu %2\n\t"
		"cmpw %0, %2\n\t"
		"bne- 0b"
		: "=r"(tbu), "=r"(tbl), "=r"(tmp)
		:
		: "cc");

	return (((u64)tbu)<<32) + tbl;
}

unsigned long long getusec()
{
	return mftb() / 60.766322;
}

void mainloop(void)
{
	int line;
	int count=0;
	
	wavoutStart();
	
	for(;;) {
		for(line=0; line<154; line++)
			gb_run();
		
		if(tvmode == VI_PAL)
			count++;
		if (count < 5){
			VIDEO_SetNextFramebuffer(xfb[pg_drawframe]);
			VIDEO_Flush();
			VIDEO_WaitVSync();

			pg_drawframe ^= 1;
			skip = 0;
		}
		else{
			skip = 1;
			count = 0;
		}
		
		if(bMenu){
			wavoutStop();
			rin_menu();
			wavoutStart();
			bMenu = 0;
		}
	}
}

int main ()
{
	PAD_Init();
	screenInit();
	wavoutInit();
	configInit();

    fatInitDefault();
	
	/* first check if directory exist */
    DIR_ITER *dir = diropen("/RINSAVE");
    if (dir == NULL) mkdir("/RINSAVE",S_IRWXU);
    else dirclose(dir); 
   
    bMenu = 1;
	/*while(load_rom()<=0)
		;*/
	
	mainloop();
	
	return 0;
}
